from pathlib import Path
from typing import List

from pydantic_settings import BaseSettings


class Settings(BaseSettings):
    PROJECT_NAME: str = "Simple Todo App"
    PROJECT_DESCRIPTION: str = "A simple todo application built with FastAPI and SQLite"
    PROJECT_VERSION: str = "0.1.0"
    
    # CORS settings
    CORS_ORIGINS: List[str] = ["*"]
    
    # Database settings
    DB_DIR: Path = Path("/app") / "storage" / "db"
    DB_FILE: Path = DB_DIR / "db.sqlite"
    SQLALCHEMY_DATABASE_URL: str = f"sqlite:///{DB_FILE}"
    
    class Config:
        case_sensitive = True


settings = Settings()